## fcitx-keyboard 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(fcitx-xkb)

option(ENABLE_TEST "Enable Unit test" Off)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

find_package(Fcitx 4.2.0 REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(X11 REQUIRED)
find_package(XkbFile REQUIRED)
find_package(Enchant REQUIRED)
find_package(IsoCodes REQUIRED)
find_package(Gettext REQUIRED)
find_package(Libiconv REQUIRED)
find_package(ICU REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions(-D_GNU_SOURCE)

set(LOCALEDIR ${CMAKE_INSTALL_PREFIX}/share/locale)

find_program(some_x_program NAMES iceauth xrdb xterm)
if (NOT some_x_program)
    set(some_x_program /usr/bin/xrdb)
    message("Warning: Could not determine X binary directory. Assuming /usr/bin.")
endif (NOT some_x_program)
get_filename_component(proto_xbindir "${some_x_program}" PATH)
get_filename_component(XBINDIR "${proto_xbindir}" ABSOLUTE)
get_filename_component(xrootdir "${XBINDIR}" PATH)
set(XLIBDIR "${xrootdir}/lib/X11")

configure_file(config.h.in config.h)

add_subdirectory(xkb)
add_subdirectory(im)
add_subdirectory(po)

if (ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)
endif(ENABLE_TEST)

=== im/CMakeLists.txt ===
include_directories (
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}/xkb
    ${FCITX4_FCITX_UTILS_INCLUDE_DIRS}
    ${FCITX4_FCITX_CONFIG_INCLUDE_DIRS}
    ${FCITX4_FCITX_INCLUDE_DIRS}
    ${LIBINTL_INCLUDE_DIR}
    ${LIBXML2_INCLUDE_DIR}
    ${LIBICONV_INCLUDE_DIR}
    ${ICU_INCLUDE_DIRS}
    )

set(fcitx_keyboard_SOURCES
    keyboard.c
    isocodes.c
    keyboardconfig.c
)

fcitx_add_addon(fcitx-keyboard ${fcitx_keyboard_SOURCES})
target_link_libraries(fcitx-keyboard ${ENCHANT_LIBRARIES} ${LIBXML2_LIBRARIES} ${LIBICONV_LIBRARIES} ${ICU_LIBRARIES})

fcitx_add_addon_conf_file(fcitx-keyboard.conf)
fcitx_add_configdesc_file(fcitx-keyboard.desc)

=== po/CMakeLists.txt ===
file(GLOB PO_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.po)
file(RELATIVE_PATH REL_SOURCE_ROOT ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})
if ("${REL_SOURCE_ROOT}" STREQUAL "")
    set(REL_SOURCE_ROOT ".")
endif("${REL_SOURCE_ROOT}" STREQUAL "")

set(POT_FILE fcitx-keyboard.pot)

configure_file(POTFILES.in.in ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in)

extract_fcitx_addon_conf_postring()

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/desc.po
                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/getdescpo ${PROJECT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
                   DEPENDS getdescpo)

add_custom_target(
    pot
    COMMAND INTLTOOL_EXTRACT=${INTLTOOL_EXTRACT} srcdir=${CMAKE_CURRENT_BINARY_DIR} ${INTLTOOL_UPDATE} --gettext-package fcitx-keyboard --pot
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/conf.po ${CMAKE_CURRENT_BINARY_DIR}/desc.po
    )

# Update .po files and compile them to binary .gmo files
gettext_create_translations(${POT_FILE} ALL ${PO_FILES})

=== test/CMakeLists.txt ===
include_directories(
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}/xkb
    ${PROJECT_SOURCE_DIR}/im
    ${FCITX4_FCITX_UTILS_INCLUDE_DIRS}
    ${FCITX4_FCITX_CONFIG_INCLUDE_DIRS}
    ${FCITX4_FCITX_INCLUDE_DIRS}
    ${LIBXML2_INCLUDE_DIR}
    )

add_executable(testrules
    testrules.c
    ../xkb/rules.c
    )

target_link_libraries(testrules ${FCITX4_FCITX_UTILS_LIBRARIES} ${LIBXML2_LIBRARIES})
    
add_executable(testisocodes
    testisocodes.c
    ../im/isocodes.c
    )

target_link_libraries(testisocodes ${FCITX4_FCITX_UTILS_LIBRARIES} ${LIBXML2_LIBRARIES})

add_test(NAME testrules
         COMMAND testrules "${CMAKE_CURRENT_SOURCE_DIR}/evdev.xml")
add_test(NAME testisocodes
         COMMAND testisocodes)

=== xkb/CMakeLists.txt ===
include_directories (
    ${PROJECT_BINARY_DIR}
    ${FCITX4_FCITX_UTILS_INCLUDE_DIRS}
    ${FCITX4_FCITX_CONFIG_INCLUDE_DIRS}
    ${FCITX4_FCITX_INCLUDE_DIRS}
    ${X11_INCLUDE_DIR}
    ${X11_Xkb_INCLUDE_PATH}
    ${X11_Xkblib_INCLUDE_PATH}
    ${LIBINTL_INCLUDE_DIR}
    ${LIBXML2_INCLUDE_DIR}
    )

set(fcitx_xkb_SOURCES
    xkb.c
    rules.c
    xkbconfig.c
)

fcitx_add_addon(fcitx-xkb ${fcitx_xkb_SOURCES})
target_link_libraries(fcitx-xkb ${X11_X11_LIB} ${XKBFILE_LIBRARIES} ${LIBXML2_LIBRARIES})

fcitx_add_addon_conf_file(fcitx-xkb.conf)
fcitx_add_configdesc_file(fcitx-xkb.desc)

=== debian/changelog ===
fcitx-keyboard (0.1.0-1) unstable; urgency=low

  * Initial release (Closes: #658146)

 -- YunQiang Su <wzssyqa@gmail.com>  Mon, 06 Feb 2012 12:19:43 +0800

=== debian/control ===
Source: fcitx-keyboard
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8.0.0), cmake, fcitx-libs-dev (>=1:4.2.0),
  libxml2-dev, libx11-dev, libxkbfile-dev, libenchant-dev, iso-codes, 
  intltool, libicu-dev
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/fcitx
Vcs-Git: git://git.debian.org/pkg-ime/fcitx-keyboard.git
Vcs-Browser: http://git.debian.org/?p=pkg-ime/fcitx-keyboard.git

Package: fcitx-keyboard
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: X Keyboard Integration wtih Fcitx
 This package will make Fcitx supports spell checker based word hint, 
 and automatically keyboard layout switch.
 .
 You can use keyboard layout as a single input method, 
 and use corresponding language spell checker.
 .
 Input method can gives a hint about what keyboard layout it requires,
 for instance, pinyin will request US layout and fcitx-keyboard can 
 then switch to US layout once pinyin is used.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/default.mk
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ 
override_dh_makeshlibs:

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TEST=On

=== debian/watch ===
version=3
http://googlecode.debian.net/p/fcitx/fcitx-keyboard-(\d+.*)\.tar\.bz2

## fcitx-keyboard 0.1.1

=== debian/changelog ===
fcitx-keyboard (0.1.1-1) unstable; urgency=low

  * New upstream release

 -- Aron Xu <aron@debian.org>  Sun, 18 Mar 2012 23:22:56 +0800

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 8.0.0), cmake, fcitx-libs-dev (>=1:4.2.0),
+Build-Depends: debhelper (>= 8), cmake, fcitx-libs-dev (>= 1:4.2.0),
   libxml2-dev, libx11-dev, libxkbfile-dev, libenchant-dev, iso-codes, 
   intltool, libicu-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://code.google.com/p/fcitx
 Vcs-Git: git://git.debian.org/pkg-ime/fcitx-keyboard.git
 Vcs-Browser: http://git.debian.org/?p=pkg-ime/fcitx-keyboard.git

=== debian/rules ===
--- 
+++ 
@@ -10,4 +10,5 @@
 override_dh_makeshlibs:
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DENABLE_TEST=On
+	dh_auto_configure -- \
+		-DENABLE_TEST=ON
